#include <stdio.h>
#include <string.h>
#include <qdeck.h>

/*for memcpy*/
#include <memory.h>

#include "accept.h"
#include "cci.h"

int ReadBuffer(s,data,numBytesToRead)
/* this routine reads from the specified port, but also considers contents
   read and in buffer from the GetLine() routine.
/* return the number of chars read */
MCCIPort s;
char *data;
int numBytesToRead;
{
int numRead = 0;

	if (numBytesToRead <= s->numInBuffer) {
		memcpy(data,s->buffer,numBytesToRead);
		s->numInBuffer -= numBytesToRead;
		return(numBytesToRead);
		}
	if (s->numInBuffer > 0) {
		memcpy(data,s->buffer,s->numInBuffer);
		data += s->numInBuffer;
		numBytesToRead -= s->numInBuffer;
		numRead = s->numInBuffer;
		s->numInBuffer = 0;
		}

	numRead += NetRead(s, data, numBytesToRead);
	return(numRead);
}



char *GetLine(s) /****** this routine needs an overhaul.... */
MCCIPort s;
/* This routine returns a line read in from the socket file descriptor. 
 * The location of the string returned is good until the next call.
 * Limitation of this routine: A line read in must not be bigger than
 * the buffersize.
 * 0 returned on error
 */

{
int numBytes;
char buf2[PORTBUFFERSIZE +1];
char *endptr;
static char returnLine[PORTBUFFERSIZE * 2 +2];
register char *rptr,*ptr;
register int count;


	if (s->numInBuffer < 1) {
		/* no character in s->buffer, so fill it up */
/*
		if (!connectedToServer) {
			return(0);
			}
*/
		if (1 > (numBytes = NetRead(s, s->buffer, PORTBUFFERSIZE))) {
			/*  End Of Connection */
/*
			DisconnectFromServer(s);
*/
#ifdef DEBUG
			printf("GetLine: End of Connection\n");
#endif
			return(0);
			}
		s->numInBuffer = numBytes;
		}

	s->buffer[s->numInBuffer]='\0';
	if (!(endptr = strstr(s->buffer, "\r\n"))) {
		/* There is no <CRLF> in s->buffer */
/*
		if (!connectedToServer) {
#ifdef DEBUG
			printf("GetLine: return 0 at point 3\n");
#endif
			return(0);
			}
*/
/*
		if (! NetIsThereInput(s)) {
#ifdef DEBUG
			printf("GetLine: return 0 at point 4\n");
#endif
			return(0);
			}
*/

		/* read in <CRLF> */
		if (1 > (numBytes = NetRead(s, buf2, PORTBUFFERSIZE))) {
			/*  End Of Connection */
/*
			NNTPDisconnectFromServer(s);
*/
#ifdef DEBUG
			printf("GetLine: return 0 at point 5\n");
#endif
			return(0);
			}
		memcpy(&(s->buffer[s->numInBuffer]),buf2,numBytes);
		s->numInBuffer += numBytes;
		s->buffer[s->numInBuffer]='\0';
		if (!(endptr = strstr(s->buffer, "\r\n"))) {
			/* protocol error on server end 
			   Everything sent should be terminated with
			   a <CRLF>... just return for now */
#ifdef DEBUG
			printf("GetLine: return NULL at point 6\n");
#endif
			return(NULL);
			}
		}
	endptr++;endptr++; /* <CRLF> should be included in line*/

	/* copy the line to the returnLine s->buffer */
	count = 0;
	rptr = returnLine;
	ptr = s->buffer;
	while (ptr != endptr) {
		*rptr++ =  *ptr++;
		count++;
		}
	*rptr = '\0'; /* null terminate the return line */

	/* shift the s->buffer contents to the front */
	s->numInBuffer -= count;
/*	bcopy(ptr,s->buffer,s->numInBuffer);*/
	memcpy(s->buffer,ptr,s->numInBuffer);

	return(returnLine);
	
} /* NNTPGetLine() */


/* return a word out of the text */
void GetWordFromString(text,retStart,retEnd)
char *text;	 /* text to get a word out of */
char **retStart; /* RETURNED: start of word in text */
char **retEnd;	 /* RETURNED: end of word in text */
{
char *start;
char *end;

	if (!text) {
		*retStart = *retEnd = text;
		return;
		}

	start = text;
	while ((*start) && isspace(*start)){ /*skip over leading space*/
		start++;
		}

	end = start;
	while((*end) && (!isspace(*end))){ /* find next space */
		end++;
		}

	*retStart = start;
	*retEnd = end;
	return;
}

#ifdef MSDOS
char *DOSNAME(char *file){
  char *dosfile = malloc(strlen(file)+1);
  int i = 0;
  if (dosfile == NULL) return NULL;
  strcpy(dosfile,file);
  while(dosfile[i] != '\0')
    {
      if (dosfile[i] == '/')
	dosfile[i] = '\\';
      i = i+1;
    }
  return dosfile;
}

#endif

/* this function replaces the unix function "system" */

int SYSTEM(char *command){
    char new_command[125];
    char disk_name[2];
    char *dos_file_name;
    char *space;

  /* xv doesn't understand the disk letter at start of dos file path */
  /* i.e., it chokes on "c:/tmp/007601.jpeg" but not on "/tmp/007601.jpeg" */
  /* so let's do the work for xv                                           */
  /* command has the form: xv c:/tmp/007601.jpeg                           */

    strcpy(new_command,"doswin ");
    space = strstr(command," "); /* locate space after name of viewer */
    if (space == NULL) return EBADF; /* can't parse it */
    /* see if file name starts with "c:", etc */
    if ((strlen(space) >= 3) && (space[2] == ':'))
      {
	strncpy(new_command+7,space+1,2);  /* change drives */
	strcpy(new_command+9,"\r");
	strncpy(new_command+10,command,(space-command)+1);/* command+space*/
	strcpy(new_command+10+(space-command)+1,space+3); /* file name */
	dos_file_name=DOSNAME(space+3);
	strcat(new_command,"\rdel ");
	strcat(new_command,dos_file_name);
	free(dos_file_name);
      }
    else
      {
	strcpy(new_command,"doswin ");
	strcpy(new_command+7,command);
      }
    return(pif_start(new_command));

#if 0
  if (strncmp("xv",command,2) == 0)
    {
      strcpy(new_command,"doswin xv "); /* build a new xv command */
      strcpy(new_command+10,command+5); /* skip over the c: */
      return(pif_start(new_command));
    }
  else
    {
     strcpy(new_command,"doswin ");
     strcpy(new_command+7,command);
     return(pif_start(new_command));
    }
#endif
}

FILE* DOSFOPEN(char *filename,char *flags){

  /* Mosaic thinks c: is a subdirectory of the current directory */

  char *new_name = strchr(filename,':');
  if ((new_name != NULL) && (new_name != filename))
    new_name--;
  else
    new_name = filename;
#ifdef DVBUG
  fprintf(stderr,"Open: %s\n",new_name);
#endif
  return fopen(new_name,flags);
}

